// codeit_3.cpp : Defines the entry point for the console application.
//
#include<ctime>
#include<iostream>
#include<fstream>
#include<queue>
#include<stack>
#include<cstdio>
using namespace std;

enum directory {Up=0,Right,Down,Left};
const short DIRS=4;
const short NMAX=30;
short N;
//long times=0;


struct Cell
{
	bool is_empty() const
	{
		return cost == -2;
	}
	bool is_coloured()const
	{
		return cost == -1;
	}
	//predefined because of usage of priority_queue in read_table;
	bool operator < (const Cell& r) const
	{
		return cost < r.cost;
	}
	short row_index;
	//if dir_controler[i] == 1 it means we have already called function find_path with i neighbour for argument.i can be up,down,left or right
	short dir_controler[DIRS];
	//returns sum of all elements of dir_controler
	short get_dir_sum()const
	{
		short sum=0;
		for(short i=0;i<DIRS;i++)
			sum+=dir_controler[i];
		return sum;
	}
	short col_index;
	bool temporary_coloured;//true if the cell is coloured in current path,tried with function find_path;used to prevent counting one cell more than once in recursion
	//resets dir_controler and temporary_coloured to 0 and false;
	void reset_cell()
	{
		for(short i=0;i<DIRS;i++)
			dir_controler[i]=0;
		temporary_coloured=false;
	}
	short cost;//-1-colour;-2-empty
	Cell(short r=0,short c=0,short n=0): row_index(r),col_index(c),cost(n),temporary_coloured(false) {for(short i=0;i<DIRS;i++) dir_controler[i]=0;}
	Cell(const Cell& r): row_index(r.row_index),col_index(r.col_index),cost(r.cost),temporary_coloured(r.temporary_coloured) {for(short i=0;i<DIRS;i++) dir_controler[i]=r.dir_controler[i];}

};

Cell table[NMAX][NMAX];

//this priority_queue gives the best cell according to the strategy - to paint the cell wiht biggest number in it
priority_queue<Cell> input_sorted_cells;

//this stack conatins the path after usage of function find_path
stack<Cell> path;

//return true if the cell is empty and has uncoloured neighbours
bool is_colourable(const Cell& c)//true all neighbours are empty
{
	bool result=c.is_empty();
		if(c.row_index+1<=N-1) result = result && (!table[c.row_index+1][c.col_index].is_coloured());//down neighbour
		if(c.row_index-1>=0) result = result && (!table[c.row_index-1][c.col_index].is_coloured());//up neighbour
		if(c.col_index-1>=0) result = result && (!table[c.row_index][c.col_index-1].is_coloured());//left neighbour
		if(c.col_index+1<=N-1) result = result && (!table[c.row_index][c.col_index+1].is_coloured());//right neighbour
		return result;

}

//reads the table and pushes copies of cells,which conatin numbers,into input_sorted_cells
void read_table(ifstream& cin)
{
	short i;
	short j;
	char c;
	for(i=0;i<N;i++)
		for(j=0;j<N;j++)
		{
			cin>>c;
			switch(c)
			{
			case '#' : {
				table[i][j].cost=-2;
				table[i][j].row_index=i;
				table[i][j].col_index=j;
				break;
					   }
			case 'B' : {
				table[i][j].cost=-1;
				table[i][j].row_index=i;
				table[i][j].col_index=j;
				break;
					   }
			default : {
				cin.putback(c);
				cin>>table[i][j].cost;
				table[i][j].row_index=i;
				table[i][j].col_index=j;
				input_sorted_cells.push(table[i][j]);
				break;
					  }
			}
		}
}

//recursive function which returns true if the cell can be start of a path with lenght n or if the cell is already temporary_coloured for this path
//and its neighbours can be start of a path with lenght n;
//it references to itself with arguments - cells,neighbours of current cell,int this order - up,right,down,left.
//result of the recursion can be one of the cases:
// 1. if the cell is not colourable - returns false;
// 2. if the cell is appropriate for end of the path -returns true - the only true bottom of the recursion
// 3. if the cell can be parth of the path(it means one of its neighbours has returned true) - pushes copy of the cell into stack path and returns true
// 4. if its the fifth visit of this cell in this path(all four possible continuations have been tried) then the cell is reset and the result is false
// 5. if the cell is colourable,the function finds first possible(not tried untill now) direction(neighbour),sets it to tried(cell.dir_controler[direction]=1
//        and waits for response from recursion.if find_path(son-cell,n-1) return true it means there is way to a cell,which can be end of path with lenght n,and current 
//		  cell is added to the path and the function returns true(eventually to cell-father).
bool find_path(Cell& cell,int n)//the & is vety important,because otherwise we change copy of the cell and it wont take effect on the table,this could be a problem for temporarry_coloured stopping condition
{
	//times++;
	if(!is_colourable(cell))return false;
	/*if(cell.temporary_coloured && (cell.get_dir_sum() == DIRS)){//it's has already tried all possible directions and it's coloured
		cell.reset_cell();//for different first direction
		return false;
	}- this is not necessary,because the same thing will happen in the last two lines*/
	if(is_colourable(cell) && n==1 && (!cell.temporary_coloured) ){//if the cell is appropriate end of the path
		path.push(cell);
		return true;
	}
	//up
	if(cell.row_index-1>=0){//if there is upper cell
		if(!cell.temporary_coloured){//this is first visit of the cell or some other directions have returned false(in this case up is first tried direction so it is the first visit,but for other cases(right,down,left) if !cell.temporary_coloured is true then tried directions before that,have returned false;
			cell.temporary_coloured=true;//set current cell as temporary_coloured if there is a cycle and some of the sons or grandsons call find_path with this cell again;
			cell.dir_controler[Up]=1;//set this direction as used.
			if(find_path(table[cell.row_index-1][cell.col_index],n-1)){//check if upper cell can be part of a successfull path
				path.push(cell);
				return true;
			}
			else{//if there is no possible way going up,we should continue the path in some other direction
				//the cell.temporary_colured is set to false so we can get into right,down or left case
				//but the cell.dir_controler[up] is still == 1 so the function wont get again into this case if there is more visits of this cell
				cell.reset_cell();
			}
		}
		else{//if the function is temporary coloured and this is not the first visit in this path
			if(!cell.dir_controler[Up]){//this direction(in this case-up) is not tried
				cell.dir_controler[Up]=1;//the direction is set as used and the recursion goes in this direction
				if(find_path(table[cell.row_index-1][cell.col_index],n))return true;//but the second argument of the function find_paht is n
				//not n-1,because this cell is already counted in this path;
			}
		}
	}
	//right
	if(cell.col_index+1<=N-1){
		if(!cell.temporary_coloured){
			cell.temporary_coloured=true;
			cell.dir_controler[Right]=1;
			if(find_path(table[cell.row_index][cell.col_index+1],n-1)){
					path.push(cell);
					return true;
			}
			else{
				cell.reset_cell();
			}
		}
		else{
			if(!cell.dir_controler[Right]){
				cell.dir_controler[Right]=1;
				if(find_path(table[cell.row_index][cell.col_index+1],n))return true;
			}
		}
	}
	//down
	if(cell.row_index+1<=N-1){//if there is down neightbour
		if(!cell.temporary_coloured){
			cell.temporary_coloured=true;
			cell.dir_controler[Down]=1;
			if(find_path(table[cell.row_index+1][cell.col_index],n-1)){//check if downer neighbour can be part of the path
				path.push(cell);
				return true;
			}
			else{
				cell.reset_cell();
			}
		}
		else{
			if(!cell.dir_controler[Down]){
				cell.dir_controler[Down]=1;
				if(find_path(table[cell.row_index+1][cell.col_index],n))return true;
			}
		}
	}
	
	//left
	if(cell.col_index-1>=0){
		if(!cell.temporary_coloured){
			cell.temporary_coloured=true;
			cell.dir_controler[Left]=1;
			if(find_path(table[cell.row_index][cell.col_index-1],n-1)){
				path.push(cell);
				return true;
			}
			else{
				cell.reset_cell();
			}
		}
		else{
			if(!cell.dir_controler[Left]){
				cell.dir_controler[Left]=1;
				if(find_path(table[cell.row_index][cell.col_index-1],n))return true;
			}
		}
	}
	//cell.reset_cell();//if this line is executed it means,this is the fifth visit of the cell and all four directions are tried(and n!=1 -current cell is not appropriate end of the path) or
	// there is no possible way starting or including this cell,so the result is false
	return false;
}

//prints the path remembered int stack path
void print_path(ofstream& cout)
{
	while(!path.empty())
	{
		cout<<path.top().row_index<<" "<<path.top().col_index<<endl;
		path.pop();
	}
	return ;
}

int main()
{
	//unsigned stime=clock();////////////////////////////////////////////////////////////////////
	ifstream gin("game.in");
	ofstream gout("game.out");
	gin >> N;
	read_table(gin);
	while(!input_sorted_cells.empty())
	{
		Cell c=input_sorted_cells.top();
		if(c.cost == 0){
			gout<<0<<endl;//replace cout;
			return 0;
		}
		table[c.row_index][c.col_index].cost=-2;//set the cell as empty,so it can be counted as colourable
		//unsigned t=clock();////////////////////////////////////////////
		if(find_path(table[c.row_index][c.col_index],c.cost)){//if the function find_path is called with input_sorted_cells.top() it wont give us right answer,because input_sorted_cells are copies of table cells and they haven't neighbours;
			//cout<<"find_path_time "<<(double)((clock()-t)/CLOCKS_PER_SEC)<<endl;////////////////////////////////////////////////////
			table[c.row_index][c.col_index].cost=c.cost;//set the original cost
			//unsigned print_time=clock();////////////////////////////////////////////////////////
			gout<<c.cost<<endl;//replace cout
			print_path(gout);//replace cout
			//cout<<"print_time "<<(double)((clock()-print_time)/CLOCKS_PER_SEC)<<endl;/////////////////////////////////////////////////////
			break;//there is printed possibel staining with the biggest possible number in some cell
		}
		table[c.row_index][c.col_index].cost=c.cost;
		input_sorted_cells.pop();
	}
	if(input_sorted_cells.empty())gout<<0<<endl;//replace cout
	//unsigned etime=clock();//////////////////////////////////
	//cout<<(double)(stime-etime)/(double) CLOCKS_PER_SEC<<endl;//////////////////////////////////
	//cout<<times<<endl;//////////////////////////////////////////
	/*for(short i=0;i<N;i++)
	{
		for(short j=0;j<N;j++)
			cout<<table[i][j].cost<<" ";
		cout<<endl;
	}*/
	//system("pause");
	return 0;
}

